%global build_sample 0
%global dbus_send /bin/dbus-send

Name: oddjob
Version: 0.27
Release: 11%{?dist}
Source: http://people.redhat.com/nalin/oddjob/oddjob-%{version}-1.tar.gz
Patch0: oddjob-0.27-sigpipe-umask.patch
Patch1: oddjob-0.27-selinux-tmi.patch
Summary: A D-BUS service which runs odd jobs on behalf of client applications
License: BSD
Group: System Environment/Daemons
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: dbus-devel >= 0.22, libselinux-devel, libxml2-devel
BuildRequires: pam-devel, python-devel, pkgconfig
BuildRequires: cyrus-sasl-devel, krb5-devel, openldap-devel
BuildRequires: docbook-dtds, xmlto
Requires(post): /sbin/service
Requires(post): /sbin/chkconfig
Requires(post): %{dbus_send}
Requires(pre): /sbin/chkconfig
URL: http://people.redhat.com/nalin/oddjob/
Requires: %{name}-libs = %{version}-%{release}

%description
oddjob is a D-BUS service which performs particular tasks for clients which
connect to it and issue requests using the system-wide message bus.

%package devel
Group: Development/Libraries
Summary: Files for developing oddjob clients
Requires: %{name} = %{version}-%{release}
Requires: pkgconfig

%description devel
This package contains header files and static libraries which aid in the
development of simple oddjob client applications.  More complex clients
can of course use D-BUS APIs directly.

%package libs
Group: System Environment/Libraries
Summary: Libraries used by oddjob clients
Requires: %{name} = %{version}-%{release}

%description libs
This package contains dynamic libraries which are used by simple oddjob client
applications.

%package sample
Group: System Environment/Daemons
Summary: A sample oddjob service.
Requires: %{name} = %{version}-%{release}

%description sample
This package contains a trivial sample oddjob service.

%prep
%setup -q -n %{name}-%{version}-1
%patch0 -p0 -b .sigpipe_umask
%patch1 -p1 -b .selinux_tmi

%build
sample_flag=
%if %{build_sample}
sample_flag=--enable-sample
%endif
%configure \
	--disable-static \
	--with-selinux-acls=default \
	--with-selinux-labels \
	--with-python --enable-xml-docs --enable-compat-dtd \
	$sample_flag
make %{_smp_mflags}

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -fr "$RPM_BUILD_ROOT"
make install DESTDIR="$RPM_BUILD_ROOT"
rm -f "$RPM_BUILD_ROOT"/%{_libdir}/security/*.la
rm -f "$RPM_BUILD_ROOT"/%{_libdir}/security/*.a
if ! test -d "$RPM_BUILD_ROOT"/%{_lib}/security ; then
	mkdir -p "$RPM_BUILD_ROOT"/%{_lib}/security
	mv "$RPM_BUILD_ROOT"/%{_libdir}/security/*.so "$RPM_BUILD_ROOT"/%{_lib}/security/
fi
# Recommended, though I disagree.
rm -f "$RPM_BUILD_ROOT"/%{_libdir}/*.la
rm -f "$RPM_BUILD_ROOT"/%{_libdir}/python*/site-packages/*.la

%if ! %{build_sample}
# Go ahead and build the sample layout.
mkdir -p sample-install-root/sample/{%{_sysconfdir}/{dbus-1/system.d,%{name}d.conf.d},%{_libdir}/%{name}}
install -m644 sample/oddjobd-sample.conf sample-install-root/sample/%{_sysconfdir}/%{name}d.conf.d/
install -m644 sample/oddjob-sample.conf  sample-install-root/sample/%{_sysconfdir}/dbus-1/system.d/
install -m755 sample/oddjob-sample.sh    sample-install-root/sample/%{_libdir}/%{name}/
%endif

# Create some compatibility symlinks
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/%{name}
pushd $RPM_BUILD_ROOT/%{_libdir}/%{name}
ln -s ../../libexec/%{name}/* .
popd

# Make sure the datestamps match in multilib pairs.
touch -r src/oddjobd.conf.in  $RPM_BUILD_ROOT/%{_sysconfdir}/oddjobd.conf

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -fr "$RPM_BUILD_ROOT"

%files
%defattr(-,root,root)
%doc *.dtd COPYING QUICKSTART python/sample.py doc/oddjob.html
%if ! %{build_sample}
%doc sample-install-root/sample
%endif
%{_initrddir}/oddjobd
%{_bindir}/*
%{_sbindir}/*
%config(noreplace) %{_sysconfdir}/dbus-*/system.d/oddjob.conf
%config(noreplace) %{_sysconfdir}/oddjobd.conf
%dir %{_sysconfdir}/oddjobd.conf.d
%config %{_sysconfdir}/oddjobd.conf.d/oddjobd-introspection.conf
%dir %{_sysconfdir}/%{name}
%dir %{_libexecdir}/%{name}
%{_libexecdir}/%{name}/mkhomedir
%{_libexecdir}/%{name}/sanity.sh
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/mkhomedir
%{_libdir}/%{name}/sanity.sh
%{_mandir}/*/oddjob*.*

%files libs
%defattr(-,root,root)
%{_libdir}/liboddjob.so.*
%{_libdir}/python*/site-packages/*
/%{_lib}/security/*.so
%{_mandir}/*/pam_*.*

%files devel
%defattr(-,root,root)
%{_includedir}/*
%{_libdir}/pkgconfig/oddjob.pc
%{_libdir}/liboddjob.so

%if %{build_sample}
%files sample
%defattr(-,root,root)
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/oddjob-sample.sh
%config %{_sysconfdir}/dbus-*/system.d/oddjob-sample.conf
%config %{_sysconfdir}/oddjobd.conf.d/oddjobd-sample.conf
%endif

%post
/sbin/chkconfig --add oddjobd
# Adjust older configuration files that may have been modified so that they
# point to the current location of the helper.
cfg=%{_sysconfdir}/oddjobd.conf
if grep -q %{_libdir}/%{name}/mkhomedir $cfg ; then
	sed -i 's^%{_libdir}/%{name}/mkhomedir^%{_libexecdir}/%{name}/mkhomedir^g' $cfg
fi
if [ -f /var/lock/subsys/oddjobd ] ; then
	%{dbus_send} --system --dest=com.redhat.oddjob /com/redhat/oddjob com.redhat.oddjob.reload
fi

%preun
if [ $1 -eq 0 ] ; then
	/sbin/service oddjobd stop > /dev/null 2>&1
	/sbin/chkconfig --del oddjobd
fi

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%changelog
* Tue Aug 10 2010 Nalin Dahyabhai <nalin@redhat.com> 0.27-11
- backport changes to not bother asking about SELinux contexts when we're
  not going to be using that information (#510457)

* Tue Jul 27 2010 Nalin Dahyabhai <nalin@redhat.com> 0.27-10
- backport changes to prevent the configuration files from conflicting on
  multilib systems (#476255)

* Mon Dec 10 2006 Nalin Dahyabhai <nalin@redhat.com> 0.27-9
- oddjob_mkhomedir: apply the umask to files as well as directories (#246681)

* Fri Dec  7 2006 Nalin Dahyabhai <nalin@redhat.com> 0.27-8
- backport change to block SIGPIPE in oddjobd, so that if a helper exits
  early, we get a write error rather than catastrophe (#246681)
- oddjob_mkhomedir: spew an error message if the umask can't be parsed into
  a number properly (#246681)
- pam_oddjob_mkhomedir.8: note that the module doesn't take arguments

* Thu Jul 25 2006 Nalin Dahyabhai <nalin@redhat.com> 0.27-7
- unmark the init script as a %%config file (part of #197182)

* Thu Jul 20 2006 Nalin Dahyabhai <nalin@redhat.com> 0.27-6
- rebuild

* Thu Jul 20 2006 Nalin Dahyabhai <nalin@redhat.com> 0.27-5
- rebuild

* Thu Jul 20 2006 Nalin Dahyabhai <nalin@redhat.com> 0.27-4
- rebuild

* Thu Jul 20 2006 Nalin Dahyabhai <nalin@redhat.com> 0.27-3
- rebuild

* Thu Jul 20 2006 Nalin Dahyabhai <nalin@redhat.com> 0.27-2
- rebuild

* Wed Jul 19 2006 Nalin Dahyabhai <nalin@redhat.com> 0.27-1
- update to 0.27-1:
  - don't attempt to subscribe to all possible messages -- the message bus
    will already route to us messages addressed to us, and if we try for
    more than that we may run afoul of SELinux policy, generating spewage
- add a build dependency on pkgconfig, for the sake of FC3
- update docs and comments because D-BUS is now called D-Bus

* Tue May  2 2006 Nalin Dahyabhai <nalin@redhat.com> 0.26-4
- rebuild

* Tue May  2 2006 Nalin Dahyabhai <nalin@redhat.com> 0.26-3
- rebuild

* Tue May  2 2006 Nalin Dahyabhai <nalin@redhat.com> 0.26-2
- rebuild

* Tue May  2 2006 Nalin Dahyabhai <nalin@redhat.com> 0.26-1
- update to 0.26-1:
  - don't get confused when ACL entries for introspection show up in the
    configuration before we add the handlers for them
  - export $ODDJOB_CALLING_USER to helpers

* Tue May  2 2006 Nalin Dahyabhai <nalin@redhat.com>
- add recommended dependency on pkgconfig in the -devel subpackage

* Tue Apr 11 2006 Nalin Dahyabhai <nalin@redhat.com> 0.25-8
- rebuild

* Tue Apr 11 2006 Nalin Dahyabhai <nalin@redhat.com> 0.25-7
- rebuild

* Tue Apr 11 2006 Nalin Dahyabhai <nalin@redhat.com> 0.25-6
- rebuild

* Tue Apr 11 2006 Nalin Dahyabhai <nalin@redhat.com> 0.25-5
- rebuild

* Tue Apr 11 2006 Nalin Dahyabhai <nalin@redhat.com> 0.25-4
- rebuild

* Tue Apr 11 2006 Nalin Dahyabhai <nalin@redhat.com> 0.25-3
- rebuild

* Tue Apr 11 2006 Nalin Dahyabhai <nalin@redhat.com> 0.25-2
- rebuild

* Tue Apr 11 2006 Nalin Dahyabhai <nalin@redhat.com> 0.25-1
- update to 0.25:
  - add introspection for parents of objects specified in the configuration
  - oddjobd can reload its configuration now
  - add -u (umask) and -s (skeldir) flags to the mkhomedir helper

* Tue Feb 28 2006 Nalin Dahyabhai <nalin@redhat.com> 0.24-1
- update to 0.24, fixing some build errors against D-BUS 0.30-0.33
- require xmlto, because the generated HTML differs depending on whether
  or not we know how to enforce ACLs which include SELinux context info
- build with DocBook 4.3

* Mon Feb 27 2006 Nalin Dahyabhai <nalin@redhat.com> 0.23-3
- rebuild

* Mon Feb 27 2006 Nalin Dahyabhai <nalin@redhat.com> 0.23-2
- rebuild

* Fri Jan 27 2006 Nalin Dahyabhai <nalin@redhat.com> 0.23-1
- fix compilation against older versions of D-BUS if the
  GetConnectionSELinuxSecurityContext method turns out to be available

* Mon Jan 16 2006 Nalin Dahyabhai <nalin@redhat.com> 0.22-1
- fix some path mismatches in the sample configuration files
- don't try to set a reconnect timeout until after we've connected

* Mon Jan  9 2006 Nalin Dahyabhai <nalin@redhat.com> 0.21-3
- prefer BuildRequires: to BuildPrereq (#176452)
- require /sbin/service at uninstall-time, because we use it (#176452)
- be more specific about when we require /sbin/chkconfig (#176452)

* Fri Jan  6 2006 Nalin Dahyabhai <nalin@redhat.com> 0.21-2
- add some missing build-time requirements

* Thu Dec 22 2005 Nalin Dahyabhai <nalin@redhat.com> 0.21-1
- fix the location for the sample D-BUS configuration doc file
- own more created directories

* Thu Dec 22 2005 Nalin Dahyabhai <nalin@redhat.com> 0.20-1
- update to 0.20
- break shared libraries and modules for PAM and python into a subpackage
  for better behavior on multilib boxes
- if we're not building a sample subpackage, include the sample files in
  the right locations as %%doc files
